/*******************************************************

	iV~[Vu΁v

		LN^f[^iu[W[Yj

 *******************************************************/

#include	<stdio.h>

#include	"sakiba.h"
#include	"chranim.h"


/************************
    XvCgp^[
 ************************/
static CODE	walk0_l[] = {0x0000, 0x0010};		/* ʏ */
static CODE	walk1_l[] = {0x0001, 0x0011};
static CODE	walk2_l[] = {0x0002, 0x0012};
static CODE	walk0_r[] = {0x0003, 0x0013};
static CODE	walk1_r[] = {0x0004, 0x0014};
static CODE	walk2_r[] = {0x0005, 0x0015};
static CODE	stand[]   = {0x0006, 0x0016};

static CODE	punch0[]  = {0x0007, 0x0017};		/* p` */
static CODE	punch1[]  = {0x0008, 0x0018};
static CODE	punch2[]  = {0x0009, 0x0019};
static CODE	punch3[]  = {0x4009, 0x4019};

static CODE	jump0[]   = {0x000a, 0x001a};		/* Wv */
static CODE	jump1[]   = {0x000b, 0x001b};
static CODE	jump2[]   = {0x000c, 0x001c};
static CODE	jump3[]   = {0x000d, 0x001d};

static CODE	guard_l[] = {0x000e, 0x001e};		/* h */
static CODE	guard_r[] = {0x000f, 0x001f};

static CODE	lose[]    = {0x0020, 0x0030};		/*  */

static CODE	glove_l[] = {0x012f};			/* O[u */
static CODE	glove_r[] = {0x412f};

static CODE	piyo0[]   = {0x022b};			/* Ђ悱 */
static CODE	piyo1[]   = {0x022c};
static CODE	piyo2[]   = {0x022d};
static CODE	piyo3[]   = {0x022e};


enum {	WALK0 = 0, WALK1, WALK2, BACK0, BACK1, BACK2, STAND0, GUARD, LOSE,
	PUNCH0, PUNCH1, PUNCH2, PUNCH3, JUMP0, JUMP1, JUMP2, JUMP3,
	GLOVE, PIYO0, PIYO1, PIYO2, PIYO3,
	STAND1 = WALK0, STAND2 = BACK0,
	PAT_END
};

static
CHR_PAT	chr_pat[] = {
		{1, 2, walk0_l, walk0_r},		/* ʏ */
		{1, 2, walk1_l, walk1_r},
		{1, 2, walk2_l, walk2_r},
		{1, 2, walk0_r, walk0_l},
		{1, 2, walk1_r, walk1_l},
		{1, 2, walk2_r, walk2_l},
		{1, 2, stand, stand},

		{1, 2, guard_l, guard_r},		/* h */

		{1, 2, lose, lose},			/*  */

		{1, 2, punch0, punch1},			/* p` */
		{1, 2, punch1, punch0},
		{1, 2, punch2, punch3},
		{1, 2, punch3, punch2},

		{1, 2, jump0, jump0},			/* Wv */
		{1, 2, jump1, jump2},
		{1, 2, jump3, jump3},
		{1, 2, jump2, jump1},

		{1, 1, glove_l, glove_r},		/* O[u */

		{1, 1, piyo0, piyo0},			/* Ђ悱 */
		{1, 1, piyo1, piyo1},
		{1, 1, piyo2, piyo2},
		{1, 1, piyo3, piyo3}
};


#define	V(n, dn, ddn, t)	(int)((n)*65536.0),(int)((dn)*65536.0),(int)((ddn)*65536.0),t

/****************
    V[PX
 ****************/
static
int	xy0[] = {	V(0.0, 0.0, 0.0, SEQ_END)
	};

/*** ʏ *******/
static
short	normal_pat[] = {WALK0, 6, WALK1, 20, WALK0, 12, WALK2, 20, WALK0, 6, SEQ_LOOP};
static
int	normal_x[] = {	V(0.0, 0.24, -0.24*2/32, 32), V(0.0, -0.24, 0.24*2/32, 32),
			V(0.0, 0.0, 0.0, SEQ_LOOP)
	};

/*** h *******/
static
short	guard_pat[] = {GUARD, SEQ_LOOP};

/*** 炢 *******/
static
short	damage_pat[] = {JUMP0, SEQ_LOOP};
static
int	damage_x[] = {	V(0.0, -1.5, 1.5/8, 8), V(-6.0, 0.0, 0.0, 32),
			V(-6.0, 6.0/32, 0.0, 32), V(0.0, 0.0, 0.0, SEQ_END)
	};
static
int	damage_y[] = {	V(1.0, 0.0, 5.0*2/8/8, 8),
			V(4.0, 0.0, 0.0, SEQ_END)
	};

/*** o *******/
static
short	ready_pat[] = {PUNCH0, 24, STAND1, 8, STAND0, 4, STAND2, 4,
			PUNCH1, 24, STAND2, 8, STAND0, 4, STAND1, 4,
			SEQ_LOOP};
static
int	ready_x[] = {	V(2.0, 1.0, -1.0/2, 2), V(3.5, 0.0, 0.0, 22),
			V(0.0, 0.0, 0.0, 10 + 6),
			V(-2.0, -1.0, 1.0/2, 2), V(-3.5, 0.0, 0.0, 22),
			V(0.0, 0.0, 0.0, 10 + 6),
			V(0.0, 0.0, 0.0, SEQ_LOOP)
	};

/***  *******/
static
short	win_pat[] = {PUNCH3, 8, JUMP0, 16, PUNCH2, 16 + 4, JUMP0, 16, PUNCH3, 8 + 4,
			SEQ_LOOP};
static
int	win_x[] = {	V(-4.0, 8.0/32, 0.0, 32), V(4.0, 0.0, 0.0, 4),
			V(4.0, -8.0/32, 0.0, 32), V(-4.0, 0.0, 0.0, 4),
			V(-4.0, 0.0, 0.0, SEQ_LOOP)
	};
static
int	win_y[] = {	V(0.0, -1.2, 1.2*2/32, 32), V(0.0, 0.0, 0.0, 4),
			V(0.0, 0.0, 0.0, SEQ_LOOP)
	};

/***  *******/
static
short	lose_pat[] = {LOSE, SEQ_LOOP};

static
short	piyo_pat[] = {PIYO0, 8, PIYO1, 8, PIYO2, 8, PIYO3, 8, SEQ_LOOP};
static
int	piyo_y[] = {	V(-10.0, 0.0, 0.0, SEQ_END)
	};

/*** S_ *******/
static
short	punch1_pat[] = {STAND1, 32, PUNCH0, 24, SEQ_END};
static
int	punch1_x[] = {	V(0.0, 0.0, 0.0, 32),
			V(2.0, 1.0, -1.0/2, 2), V(3.5, 0.0, 0.0, SEQ_END)
	};

static
short	glove1_pat[] = {NOPUT, 32 + 8, GLOVE, 16, SEQ_END};
static
int	glove1_x[] = {	V(3.5, 0.0, 0.0, 32 + 8), V(3.5, 0.0, (58.0 - 3.5)*2/16/16, 16),
			V(58.0, 0.0, 0.0, SEQ_END)
	};

static
short	punch2_pat[] = {PUNCH0, 8 + 24, JUMP0, 12, STAND0, 20, SEQ_END};
static
int	punch2_x[] = {	V(3.5, 0.0, 0.0, 8 + 24), V(1.0, 0.0, 0.0, 12),
			V(0.0, 0.0, 0.0, SEQ_END)
	};
static
int	punch2_y[] = {	V(0.0, 0.0, 0.0, 8 + 24), V(3.0, 0.0, 0.0, 12),
			V(0.0, 0.0, 0.0, SEQ_END)
	};

static
short	glove2_pat[] = {GLOVE, 8, NOPUT, 56, SEQ_END};
static
int	glove2_x[] = {	V(58.0, 0.0, 0.0, SEQ_END)
	};

/*** qbvA^bN *******/
static
short	hip1_pat[] = {JUMP1, 12, STAND1, 4 + 4, JUMP1, 36, JUMP0, 4, JUMP3, 8, SEQ_END};
static
int	hip1_x[] = {	V(0.0, -1.0, 0.0, 16), V(-16.0, 0.0, 0.0, 4),
			V(-16.0, 76.0/48, 0.0, 48), V(60.0, 0.0, 0.0, SEQ_END)
	};
static
int	hip1_y[] = {	V(0.0, -2.0, 2.0*2/16, 16), V(0.0, 0.0, 0.0, 4),
			V(0.0, -4.0, 4.0*2/50, 48), V(-8.0, 0.0, 0.0, SEQ_END)
	};

static
short	hip2_pat[] = {JUMP3, 12 + 32,
			BACK0, 4, BACK1, 6, BACK0, 4, BACK2, 6,
			BACK0, 4, BACK1, 6, BACK0, 10, SEQ_END};
static
int	hip2_x[] = {	V(60.0, -0.5, 0.0, 12), V(54.0, 0.0, 0.0, 32),
			V(54.0, 0.0, -27.0*2/20/20, 20),
			V(27.0, -27.0*2/20, 27.0*2/20/20, 20),
			V(0.0, 0.0, 0.0, SEQ_END)
	};
static
int	hip2_y[] = {	V(-8.0, 0.0, 1.0*2/12, 12), V(4.0, 0.0, 0.0, 32),
			V(0.0, 0.0, 0.0, SEQ_END)
	};


#define	NUL3	{NULL, NULL, NULL}

/**********************
    LN^f[^
 **********************/
CHR_DATA	chr_jeans = {
			{2, 6, 8,			/* U */
				"100_",
				{{glove1_pat, glove1_x, xy0}, {punch1_pat, punch1_x, xy0}},
				{{glove2_pat, glove2_x, xy0},
					{punch2_pat, punch2_x, punch2_y}}
			},
			{5, 7, 16,			/* U */
				"˯߱",
				{{hip1_pat, hip1_x, hip1_y}, NUL3},
				{{hip2_pat, hip2_x, hip2_y}, NUL3}
			},

			"W[",			/* LN^ */
			"JEANS",			/* XvCgt@C */
			{"JEANS1", "JEANS2"},		/* pbgt@C */
			chr_pat,			/* LN^p^[ */
			{				/* Aj[VV[PX */
			{{normal_pat, normal_x, xy0}, NUL3},		/* ʏ */
			{{guard_pat, xy0, xy0}, NUL3},			/* h */
			{{damage_pat, damage_x, damage_y}, NUL3},	/* 炢 */
			{{ready_pat, ready_x, xy0}, NUL3},		/* o */
			{{win_pat, win_x, win_y}, NUL3},		/*  */
			{{lose_pat, xy0, xy0}, {piyo_pat, xy0, piyo_y}}	/*  */
			}
		};

/********************* End of File ******************************************/