/*********************************************

	iV~[Vu΁v

				C

 *********************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<sys\iocs.h>
#include	<sys\dos.h>

#include	"sakiba.h"
#include	"screen.h"
#include	"chranim.h"
#include	"select.h"
#include	"pad.h"
#include	"sound.h"


CHR_PARAM	chr_param[2];		/* LN^p[^ */

int	turn;				/* ^[ */
int	mode;				/* [h */

static Bool	watch;			/* ϐ탂[h */


/*******************************************
    LN^V[PXݒ
		 chr = LN^
		seq1 = V[PXi{́j
		seq2 = V[PXiTuj
		 num = V[PXԍ
 *******************************************/
static
void	chr_sequence(CHR_PARAM* chr, SEQUENCE* seq1, SEQUENCE* seq2)
{
	set_sequence(&chr->spr[0], seq1->pat ? seq1 : NULL);		/* { */
	set_sequence(&chr->spr[1], seq2->pat ? seq2 : NULL);		/* Tu */
}

static
void	chr_sequence2(CHR_PARAM* chr, int num)
{
	chr_sequence(chr, &chr->data->seq[num][0], &chr->data->seq[num][1]);
}

/*******************************************
    LN^
		 chr = p[^obt@
		 num = vC[ԍ
		 opr = 
		data = LN^f[^
 *******************************************/
void	init_chr(CHR_PARAM* chr, int num, int opr, CHR_DATA* data)
{
	ACTION*	p;
	int	i;

	chr->num = num;				/* vC[ԍ */
	chr->operation = opr;			/*  */
	chr->data = data;			/* f[^ */

	load_chr(chr);				/* LN^XvCgǂݍ */

	chr->hit_point = chr->d_hp = HP_MAX;	/* ̗ */
	for (i = 0, p = chr->action; i < 6; i++, p++) {		/* s */
		switch ( i ) {
		  case 0 :			/* \O */
			p->kind  = ACT_SUKI;
			p->count = (num == PLAYER1) ? (rnd(3) + 1) : (rnd(2) + 1);
			break;
		  case 1 :			/* h */
			p->kind  = ACT_GUARD;
			p->count = GUARD_CNT;
			break;
		  default :			/*  */
			p->kind = -1;
			break;
		}
	}
}

/**************************************
    LN^Aji߂
		num = vC[ԍ
	߂l	Aj[VI[
 **************************************/
static
Bool	anim_chr(int num)
{
	anim_spr(&chr_param[num].spr[1]);		/* Tu */
	return	anim_spr(&chr_param[num].spr[0]);	/* { */
}


/******************************
    LN^o
	߂l	 TRUE : s
		FALSE : I
 ******************************/
static
Bool	ready_chr(void)
{
	int	i;

	mode = MODE_READY;				/* oꃂ[h */
	chr_sequence2(&chr_param[PLAYER1], SEQ_READY);	/* oV[PX */
	chr_sequence2(&chr_param[PLAYER2], SEQ_READY);
	for (i = 0; i < 250; i++) {
		anim_chr(PLAYER1);			/* LN^Aj[V */
		anim_chr(PLAYER2);
		draw_screen();				/* ʕ` */
		if ( esc_key ) {			/* Q[I */
			return	FALSE;
		}

		if ( i == 100 ) {			/* \ */
			chr_sequence2(&chr_param[PLAYER1], SEQ_NORMAL);
			chr_sequence2(&chr_param[PLAYER2], SEQ_NORMAL);
		}
		else if ( i == 130 ) {
			set_message(MES_READY);		/* Ready */
		}
		else if ( i == 200 ) {
			set_message(MES_FIGHT);		/* Fight */
		}
	}
	set_message(-1);				/* bZ[W */
	return	TRUE;
}

/************************************
    퓬I
		win = 
	߂l	 TRUE : Q[s
		FALSE : Q[I
 ************************************/
static
Bool	end_battle(int win)
{
	int	i;

	set_message((win == PLAYER1) ? MES_1P : MES_2P);	/* Win */
	fadeout_music();				/* afltF[hAEg */
	for (i = 0; i < 370; i++) {
		anim_chr(PLAYER1);			/* LN^Aj[V */
		anim_chr(PLAYER2);
		draw_screen();				/* ʕ` */
		if ( esc_key ) {			/* Q[I */
			return	FALSE;
		}

		if ( (i < 250) && ((get_push(0) & PAD_A) || (get_push(1) & PAD_A)) ) {
			i = 250;
		}

		if ( i == 250 ) {
			_iocs_contrast(0);		/* tF[hAEg */
		}
	}
	return	TRUE;
}


/*****************************
    šJグ
		 act = s
 *****************************/
static
void	move_up(ACTION* act)
{
	int	i;

	for (i = 0; i < 6 - 1; i++) {
		*act = *(act + 1);
		act++;
	}
	act->kind = -1;
}

/**********************
    COMvl
	߂l	s
 **********************/
static
int	com_action(void)
{
	ACTION	*o_act, *d_act;
	int	t;

	o_act = chr_param[turn].action;			/* ̍s */
	d_act = chr_param[turn ^ 0x01].action;		/* ̍s */

	if ( o_act[0].kind == ACT_GUARD ) {
		t = o_act[0].count - d_act[0].count;
		if ( (d_act[0].kind == ACT_ATTACK1) || (d_act[0].kind == ACT_ATTACK2) ) {
			if ( o_act[0].count < d_act[0].count ) {
				return	ACT_GUARD;
			}
			t -= d_act[1].count;
		}
	}
	else {
		if ( o_act[0].count < d_act[0].count ) {
			if ( d_act[0].kind == ACT_GUARD ) {
				t = o_act[0].count + o_act[1].count - d_act[0].count;
			}
			else {
				t = o_act[1].count - DAMAGE_CNT;
			}
		}
		else if ( (d_act[0].kind == ACT_ATTACK1) || (d_act[0].kind == ACT_ATTACK2) ) {
			t = DAMAGE_CNT - d_act[1].count;
		}
		else {
			t = o_act[0].count + o_act[1].count - d_act[0].count;
		}
	}

	if ( t > 0 ) {
		if ( rnd(9 + t) > 8 ) {
			return	ACT_ATTACK2;
		}
		if ( rnd(8 + t) > 6 ) {
			return	ACT_ATTACK1;
		}
		return	ACT_GUARD;
	}
	else {
		if ( rnd(7 - t) < 2 ) {
			return	ACT_GUARD;
		}
		if ( rnd(6 - t) > 4 ) {
			return	ACT_ATTACK2;
		}
		return	ACT_ATTACK1;
	}
}

/***********************************
    s
		chr = LN^
	߂l	s
		-1 : Q[I
 ***********************************/
static
int	input_action(CHR_PARAM* chr)
{
	PAD	pad;

	mode = MODE_INPUT;				/* ̓[h */
	while ( 1 ) {
		anim_chr(chr->num ^ 0x01);		/* LN^Aj[V */

		draw_screen();				/* ʕ` */
		pad = get_push(chr->num);		/*  */
		if ( esc_key ) {
			return	-1;			/* Q[I */
		}
		if ( pad & PAD_LEFT ) {
			return	(chr->num == PLAYER1) ? ACT_GUARD : ACT_ATTACK1;
		}
		if ( pad & PAD_RIGHT ) {
			return	(chr->num == PLAYER1) ? ACT_ATTACK1 : ACT_GUARD;
		}
		if ( pad & PAD_UP ) {
			return	ACT_ATTACK2;
		}
	}
}

/**********************************
    sI
		chr = LN^
	߂l	 TRUE : s
		FALSE : I
 **********************************/
static
Bool	select_action(CHR_PARAM* chr)
{
	ACTION*	act;
	int	n;

	act = chr->action;			/* s */
	while ( act->kind >= 0 ) {		/* 󂫌 */
		act++;
	}
	act->kind = -1;

	n = (chr->operation == OPR_PLAYER) ? input_action(chr) : com_action();
						/* s */
	switch ( n ) {
	  case ACT_GUARD :			/* h */
		act->kind = ACT_GUARD;
		act->count = GUARD_CNT;
		break;

	  case ACT_ATTACK1 :			/* U */
		act->kind = ACT_ATTACK1;
		act->count = chr->data->attack1.before;
		act++;
		act->kind = ACT_SUKI;
		act->count = chr->data->attack1.after;
		break;

	  case ACT_ATTACK2 :			/* U */
		act->kind = ACT_ATTACK2;
		act->count = chr->data->attack2.before;
		act++;
		act->kind = ACT_SUKI;
		act->count = chr->data->attack2.after;
		break;

	  default :				/* Q[I */
		return	FALSE;
	}
	return	TRUE;
}

/*******************************************
    sAj[VĐ
		slow = X[[V
 *******************************************/
static
void	play_action(Bool slow)
{
	Bool	loop = TRUE;

	while ( loop ) {
		if ( anim_chr(PLAYER1) && (turn == PLAYER1) ) {
			loop = FALSE;
		}
		if ( anim_chr(PLAYER2) && (turn == PLAYER2) ) {
			loop = FALSE;
		}
		draw_screen();				/* ʕ` */
		if ( slow ) {
			draw_screen();
		}
		if ( esc_key ) {
			return;
		}
	}
}


/********************************
    U
		atk = UZ
	߂l	
 ********************************/
static
Bool	attack(ATK_TECH* atk)
{
	CHR_PARAM	*o_chr, *d_chr;
	ACTION		*d_act;

	o_chr = &chr_param[turn];			/* U */
	d_chr = &chr_param[turn ^ 0x01];		/*  */
	d_act = d_chr->action;

	chr_sequence(o_chr, &atk->seq1[0], &atk->seq1[1]);	/* UOV[PXݒ */
	if ( d_act[0].kind == ACT_GUARD ) {		/* h */
		chr_sequence2(d_chr, SEQ_GUARD);	/* hV[PXݒ */
	}
	play_action(FALSE);				/* Aj[VĐ */

	if ( d_act[0].kind == ACT_GUARD ) {		/* h */
		d_chr->hit_point -= atk->power/2;
	}
	else {						/* qbg */
		if ( (d_act[0].kind == ACT_ATTACK1) || (d_act[0].kind == ACT_ATTACK2) ) {
			d_act[1].count += d_act[0].count;
			move_up(d_act);
		}
		d_act[0].kind  = ACT_DAMAGE;		/* 炢 */
		d_act[0].count = DAMAGE_CNT;
		d_chr->hit_point -= atk->power;
		chr_sequence2(d_chr, SEQ_DAMAGE);	/* 炢V[PXݒ */
		set_hitmark();				/* qbg}[Nݒ */
	}
	if ( d_chr->hit_point <= 0 ) {
		d_chr->hit_point = 0;
		set_message(MES_KO);			/* K.O. */
	}

	slow_bar(FALSE);
	chr_sequence(o_chr, &atk->seq2[0], &atk->seq2[1]);	/* UV[PXݒ */

	if ( d_chr->hit_point == 0 ) {			/*  */
		play_action(TRUE);			/* Aj[VĐ */
		chr_sequence2(o_chr, SEQ_WIN);
		chr_sequence2(d_chr, SEQ_LOSE);
		return	TRUE;
	}
	else {
		play_action(FALSE);			/* Aj[VĐ */
		chr_sequence2(o_chr, SEQ_NORMAL);
		chr_sequence2(d_chr, SEQ_NORMAL);
		return	FALSE;
	}
}

/********************************
    s
	߂l	
 ********************************/
static
Bool	take_action(void)
{
	CHR_PARAM*	chr;
	ACTION*		act;
	ATK_TECH*	atk;
	Bool		ret = FALSE;

	chr = &chr_param[turn];				/* LN^ */
	act = chr->action;				/* s */
	atk = NULL;
	if ( act->kind == ACT_ATTACK1 ) {		/* U */
		atk = &chr->data->attack1;
	}
	else if ( act->kind == ACT_ATTACK2 ) {		/* U */
		atk = &chr->data->attack2;
	}
	if ( --act->count == 0 ) {
		if ( atk == NULL ) {
			draw_screen();
		}
		move_up(act);				/* Jグ */
		if ( atk ) {
			ret = attack(atk);		/* U */
		}
		else {
			slow_bar(TRUE);			/* s` */
			select_action(chr);		/* sI */
		}
	}
	return	ret;
}

/************************************
    Q[C
		chr = LN^f[^
		opr = 
	߂l	 TRUE : Q[s
		FALSE : I
 ************************************/
static
Bool	game_main(CHR_DATA* chr[2], int opr[2])
{
	int	count, win;

	for (count = 0; count < 2; count++) {		/* LN^ */
		init_chr(&chr_param[count], count, opr[count], chr[count]);
	}
	play_main_bgm();				/* CBGMtJn */
	draw_start();					/* ʕ` */

	turn = PLAYER2;					/* ^[ */
	if ( !ready_chr() ) {				/* LN^o */
		return	FALSE;
	}
	count = 4;
	win = 0;
	while ( win == 0 ) {
		if ( esc_key ) {
			return	FALSE;			/* Q[I */
		}

		mode = MODE_BATTLE;			/* 퓬[h */
		anim_chr(PLAYER1);			/* LN^Aj[V */
		anim_chr(PLAYER2);
		draw_screen();				/* ʕ` */

		if ( --count == 0 ) {
			turn ^= 0x01;
			if ( take_action() ) {		/* s */
				break;
			}
			count = 4;
		}
	}

	return	end_battle(turn);			/* 퓬I */
}

/************
    C
 ************/
int	main(int argc, char* argv[])
{
	CHR_DATA*	chr[2];
	int		opr[2];

	watch = ((argc >= 2) && ((*argv[1] == 'W') || (*argv[1] == 'w')));
							/* ϐ탂[h */

	_iocs_tgusemd(0, 2);				/* OtBbNʎgp */
	_iocs_tgusemd(1, 2);				/* eLXgʎgp */
	_dos_c_curoff();				/* J[\nee */
	_iocs_crtmod(0x0e);				/* ʃ[hݒ */
	_iocs_g_clr_on();				/* OtBbNʕ\ */
	_iocs_b_bpoke((void*)0xe82500, 0x12);		/* vCIeBݒ */
	if ( init_screen() ) {				/* ʏ */
		_iocs_contrast(-2);			/* tF[hC */
		return	1;
	}
	if ( init_sound() ) {				/*  */
		_iocs_contrast(-2);			/* tF[hC */
		return	1;
	}
	srand((unsigned int)_iocs_timeget());		/*  */

	while ( 1 ) {
		if ( watch ) {
			auto_select(chr, opr);		/* I */
		}
		else if ( !select(chr, opr) ) {		/* [hELN^I */
			break;
		}
		if ( !game_main(chr, opr) ) {		/* Q[C */
			break;
		}
	}
	stop_music();					/* t~ */

	_iocs_tgusemd(0, 3);				/* OtBbNʎgp */
	_iocs_tgusemd(1, 3);				/* eLXgʎgp */
	_dos_c_width(0);				/* ʃ[hݒ */
	_dos_c_curon();					/* J[\nm */
	_dos_kflushio(0xff);				/* L[obt@NA */
	_iocs_contrast(-2);				/* tF[hC */

	return	0;
}

/****************** End of File ***************************************************/