/********************************************

	iV~[Vu΁v

				

 ********************************************/

#include	<sys\iocs.h>

#include	"sakiba.h"
#include	"pad.h"


/*** {^ɑΉL[ *******/
typedef struct {
	PAD	pad;		/* {^ */
	int	kbit[2][2];	/* L[ */
} PAD_KEY;

static PAD_KEY	pad_key[6] = {	{PAD_UP,
					{{0x02, 0x20},		/* T */
					 {0x08, 0x10}}},	/* 8 */
				{PAD_DOWN,
					{{0x05, 0x20},		/* V */
					 {0x09, 0x10}}},	/* 2 */
				{PAD_LEFT,
					{{0x04, 0x02},		/* F */
					 {0x08, 0x80}}},	/* 4 */
				{PAD_RIGHT,
					{{0x04, 0x08},		/* H */
					 {0x09, 0x02}}},	/* 6 */
				{PAD_A,
					{{0x0a, 0x20},		/* XF1 */
					 {0x0e, 0x04}}},	/* OPT.1 */
				{PAD_B,
					{{0x0a, 0x40},		/* XF2 */
					 {0x0e, 0x08}}}		/* OPT.2 */
		};


static PAD	pad_data[2] = {0xffff, 0xffff};		/* pbh̏ */
static PAD	pad_just[2];				/* ̕ω */
static PAD	pad_rept[2];				/* s[gt */
static int	pad_cnt[2] = {16, 16};			/* s[gpJE^ */

Bool	esc_key  = FALSE;			/* ESCL[ */


/********************
    pbh
 ********************/
void	pad_synch(void)
{
	PAD_KEY*	p;
	PAD		last;
	int		i, j;

	for (i = 0; i < 2; i++) {
		last = pad_data[i];			/* Ȍ */
		pad_data[i] = ~_iocs_joyget(i);		/* XeBbNf[^擾 */
		for (j = 0, p = pad_key; j < 6; j++, p++) {
			if ( _iocs_bitsns(p->kbit[i][0]) & p->kbit[i][1] ) {
				pad_data[i] |= p->pad;
			}
		}

		pad_just[i] = pad_data[i] & ~last;	/* ωf[^ */
		pad_rept[i] = pad_just[i];		/* s[gt */
		if ( pad_data[i] == last ) {
			if ( --pad_cnt[i] == 0 ) {
				pad_rept[i] = pad_data[i];
				pad_cnt[i] = 4;
			}
		}
		else {
			pad_cnt[i] = 16;
		}
	}
	if ( _iocs_bitsns(0) & 0x02 ) {		/* ESCL[ */
		esc_key = TRUE;
	}
}

/**************************************
    pbhԎ擾
		num = vC[ԍ
	߂l	pbh
 **************************************/
PAD	get_pad(int num)		/* ̂܂ */
{
	return	pad_data[num];
}

PAD	get_push(int num)		/*  */
{
	return	pad_just[num];
}

PAD	get_rept(int num)		/* s[gt */
{
	return	pad_rept[num];
}

/***************** End of File *******************************************/