
typedef	int	Bool;

#define	TRUE	1
#define	FALSE	0


typedef	unsigned short	CODE;		/* XvCgR[h */
typedef	unsigned short	COLOR;		/* F */
typedef signed long	REAL;		/*  */


#define	HP_MAX	100			/* ̗͏l */

enum {					/* s̎ */
	ACT_GUARD = 0,				/* h */
	ACT_ATTACK1,				/* U */
	ACT_ATTACK2,				/* U */
	ACT_SUKI,				/* Ǔ */
	ACT_DAMAGE,				/* U󂯂 */
	ACT_MAX,
};

enum {PLAYER1 = 0, PLAYER2};		/* vC[ */

enum {					/*  */
	OPR_PLAYER = 0,				/* l */
	OPR_COM					/* Rs[^ */
};

enum {					/* [h */
	MODE_BATTLE = 0,			/* 퓬 */
	MODE_INPUT,				/*  */
	MODE_READY				/* o */
};

enum {					/* Aj[VV[PX */
	SEQ_NORMAL,				/* ʏ */
	SEQ_GUARD,				/* h */
	SEQ_DAMAGE,				/* 炢 */
	SEQ_READY,				/* o */
	SEQ_WIN,				/*  */
	SEQ_LOSE,				/*  */
	SEQ_MAX
};

#define	GUARD_CNT	5		/* h䎝 */
#define	DAMAGE_CNT	6		/* U炢 */


/*** s *******/
typedef struct {
	int	kind;			/* s̎ */
	int	count;			/*  */
} ACTION;

/*** LN^XvCgp^[ *******/
typedef struct {
	int	w, h;			/* 傫 */
	CODE*	code_l;			/* vC[Pp^[ */
	CODE*	code_r;			/* vC[Qp^[ */
} CHR_PAT;

/*** Aj[VV[PX *******/
typedef struct {
	short*	pat;			/* p^[V[PX */
	int*	x;			/* WV[PX */
	int*	y;			/* WV[PX */
} SEQUENCE;

/*** UZ *******/
typedef struct {
	int	before;			/* O̎ */
	int	after;			/* 㓮̎ */
	int	power;			/* З */

	char*		name;			/* Z */
	SEQUENCE	seq1[2];		/* Aj[V */
	SEQUENCE	seq2[2];
} ATK_TECH;

/*** XvCgp^[pp[^ *******/
typedef struct {
	CHR_PAT*	pat;			/* `p^[ */
	short		pat_cnt;		/* p^[JE^ */
	REAL		x, dx, ddx;		/* \W */
	int		x_cnt;			/* ړJE^ */
	REAL		y, dy, ddy;		/* \W */
	int		y_cnt;			/* ړJE^ */
	SEQUENCE	seq;			/* Aj[VV[PX */
	SEQUENCE	now;
	CHR_PAT*	pat_data;		/* LN^p^[ */
} SPR_PARAM;


/*** LN^f[^ *******/
typedef struct {
	ATK_TECH	attack1;		/* U */
	ATK_TECH	attack2;		/* U */

	char*		name;			/* LN^ */
	char*		sp_name;		/* XvCgt@C */
	char*		pal_name[2];		/* pbgt@C */
	CHR_PAT*	pat_data;		/* LN^p^[ */
	SEQUENCE	seq[SEQ_MAX][2];	/* Aj[VV[PX */
} CHR_DATA;

/*** LN^p[^ *******/
typedef struct {
	int		num;			/* UAU */
	int		hit_point;		/* ̗ */
	int		d_hp;			/* \̗ */
	ACTION		action[6];		/* s */
	int		operation;		/*  */

	SPR_PARAM	spr[2];			/* XvCgp^[ */

	CHR_DATA*	data;			/* LN^f[^ */
} CHR_PARAM;


extern CHR_PARAM	chr_param[2];	/* LN^p[^ */

extern int	turn;			/* ^[ */
extern int	mode;			/* [h */


#define	rnd(n)	(rand() % (n))		/*  */

/****************** End of File *****************************************/