/*************************************************

	iV~[Vu΁v

		[hELN^ZNg

 *************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<sys\dos.h>
#include	<sys\iocs.h>

#include	"sakiba.h"
#include	"select.h"
#include	"screen.h"
#include	"pad.h"
#include	"sound.h"


/*** LN^f[^ *******/
extern CHR_DATA		chr_roba;
extern CHR_DATA		chr_penguin;
extern CHR_DATA		chr_jeans;


#define	CHR_MAX		3			/* LN^ */

#define	SPRITE_FILE	"SELECT"		/* XvCgf[^ */

#define	MODE_X		88			/* Q[[h`ʒu */
#define	MODE_Y		 8
#define	MODE_H		20

#define	CHR_X		64			/* LN^`ʒu */
#define	CHR_Y		96
#define	CHR_W		24
#define	CHR_H		40

/*** XvCgR[h *****/
#define	SPR_CURSOR1	0x0717			/* J[\ */
#define	SPR_CURSOR2	0x4617

#define	CODE0		0x40			/* XvCgi[ꏊ */
#define	PALET0		0x08			/* pbgi[ꏊ */


static
CHR_DATA*	chr_data[CHR_MAX] = {		/* LN^f[^ */
			&chr_roba,
			&chr_penguin,
			&chr_jeans
		};
static
int		chr_pace[CHR_MAX] = {		/* LN^Ajy[X */
			8, 16, 12
		};

static
char*	mode_menu[3] = {	"  vs COM",		/* Q[[h */
				"  vs MAN",
				"COM vs COM"
	};


/**********************
    Iʕ`
 **********************/
static
void	start_select(void)
{
	int	i, x, y;

	_iocs_wipe();					/* OtBbNNA */

	y = MODE_Y;
	for (i = 0; i < 3; i++) {			/* [hj[` */
		draw_str(mode_menu[i], MODE_X, y);
		y += MODE_H;
	}

	x = CHR_X + 40;
	y = CHR_Y + 8;
	for (i = 0; i < CHR_MAX; i++) {			/* LN^` */
		draw_str(chr_data[i]->name, x, y);
		x += CHR_W;
		y += CHR_H;
	}

	_iocs_contrast(-2);				/* tF[hC */
}

/******************************************
    LN^`
		f = Aj[V邩
 ******************************************/
static
void	draw_chr(Bool f)
{
	CODE	code;
	int	i, x, y, k;

	code = CODE0 + PALET0*0x100;			/* XvCgR[h */
	x = CHR_X;					/* LN^`ʒu */
	y = CHR_Y;
	for (i = 0; i < CHR_MAX; i++) {
		if ( f ) {
			k = (anim_count/chr_pace[i]) % 4;	/* Aj[V */
			k = (k == 3) ? 2 : ((k == 2) ? 0 : k);
		}
		else {
			k = 0;
		}
		put_sprite(code + k,        x + 16, y + 16);	/* XvCg` */
		put_sprite(code + k + 0x10, x + 16, y + 32);

		code += 0x103;
		x += CHR_W;
		y += CHR_H;
	}
}

/*******************************************
    [hIʕ`
		sel1, sel2 = ZNgԍ
 *******************************************/
static
void	draw_sel_mode(int sel1, int sel2)
{
	int	ssp;

	ssp = _iocs_b_super(0);			/* X[p[oCU[h */
	sprite_reg = SPRITE_REG;		/* XvCgWX^擪 */
	v_synch();				/*  */

	put_sprite(SPR_CURSOR1 + ((anim_count/8) % 3),		/* 1PJ[\` */
					MODE_X,      MODE_Y + 16 + MODE_H*sel1);
	put_sprite(SPR_CURSOR2 + ((anim_count/8) % 3),		/* 2PJ[\` */
					MODE_X + 96, MODE_Y + 16 + MODE_H*sel2);

	draw_chr(FALSE);			/* LN^` */

	while ( (unsigned long)sprite_reg < (unsigned long)(SPRITE_REG + 4*0x100) ) {
		sprite_reg += 3;
		*sprite_reg++ = 0;		/* XvCg\ */
	}
	_iocs_b_super(ssp);			/* [U[[h */
}

/************************************
    [hI
		opr = obt@
	߂l	vC[
 ************************************/
static
int	select_mode(int opr[2])
{
	static int	sel[2] = {0, 0};
	PAD	pad;
	int	i, player;

	player = -1;
	while ( player < 0 ) {
		draw_sel_mode(sel[PLAYER1], sel[PLAYER2]);	/* ʕ` */
		if ( esc_key ) {
			return	-1;			/* Q[I */
		}

		for (i = 0; i < 2; i++) {
			pad = get_rept(i);		/* pbh */
			if ( pad & PAD_A ) {		/*  */
				player = i;
			}
			else if ( (pad & PAD_UP) && (sel[i] > 0) ) {
				sel[i]--;
			}
			else if ( (pad & PAD_DOWN) && (sel[i] < 2) ) {
				sel[i]++;
			}
		}
	}
	switch ( sel[player] ) {
	  case 0 :					/* MAN vs COM */
		opr[PLAYER1] = (player == PLAYER1) ? OPR_PLAYER : OPR_COM;
		opr[PLAYER2] = (player == PLAYER2) ? OPR_PLAYER : OPR_COM;
		break;
	  case 1 :					/* MAN vs MAN */
		opr[PLAYER1] = OPR_PLAYER;
		opr[PLAYER2] = OPR_PLAYER;
		break;
	  case 2 :					/* COM vs COM */
		opr[PLAYER1] = OPR_COM;
		opr[PLAYER2] = OPR_COM;
		break;
	  default :
		break;
	}
	return	player;
}


/*******************************************
    LN^Iʕ`
		sel1, sel2 = ZNgԍ
 *******************************************/
static
void	draw_sel_chr(int sel1, int sel2)
{
	int	ssp;

	ssp = _iocs_b_super(0);			/* X[p[oCU[h */
	sprite_reg = SPRITE_REG;		/* XvCgWX^擪 */
	v_synch();				/*  */

	if ( sel1 >= 0 ) {			/* 1P */
		draw_message(MES_1P, CHR_X - 10 + CHR_W*sel1, CHR_Y + 6 + CHR_H*sel1);
	}
	if ( sel2 >= 0 ) {			/* 2P */
		draw_message(MES_2P, CHR_X + 28 + CHR_W*sel2, CHR_Y + 14 + CHR_H*sel2);
	}

	draw_chr(TRUE);				/* LN^` */

	while ( (unsigned long)sprite_reg < (unsigned long)(SPRITE_REG + 4*0x100) ) {
		sprite_reg += 3;
		*sprite_reg++ = 0;		/* XvCg\ */
	}
	_iocs_b_super(ssp);			/* [U[[h */
}

/************************************************
    LN^I
		chr = LN^f[^obt@
		num = ͑Ώ
		  t = ͐l
		  f = tF[hAEg邩
	߂l	 0 : 
		 1 : LZ
		-1 : Q[I
 ************************************************/
int	select_chr(CHR_DATA* chr[2], int num[2], int t, Bool f)
{
	static int	sel[2] = {0, 0};
	PAD	pad;
	int	i, cnt;

	cnt = 150;
	while ( cnt > 0 ) {
		draw_sel_chr((((num[0] == 0) || (num[1] == 0)) && (anim_count % 2))
								? - 1 : sel[PLAYER1],
				(((num[0] == 1) || (num[1] == 1)) && !(anim_count % 2))
									? - 1 : sel[PLAYER2]);
							/* ʕ` */
		if ( esc_key ) {
			return	-1;			/* Q[I */
		}

		for (i = 0; i < 2; i++) {
			pad = get_rept(i);
			if  ( pad & PAD_B ) {			/* LZ */
				return	1;
			}
			if ( num[i] >= 0 ) {
				if ( pad & PAD_A ) {		/*  */
					chr[num[i]] = chr_data[sel[num[i]]];
					num[i] = -1;
					t--;
				}
				else if ( (pad & PAD_UP) && (sel[num[i]] > 0) ) {
					sel[num[i]]--;
				}
				else if ( (pad & PAD_DOWN) && (sel[num[i]] < 2) ) {
					sel[num[i]]++;
				}
			}
		}

		if ( t == 0 ) {
			if ( f ) {				/* tF[hAEg */
				if ( cnt == 150 ) {
					_iocs_contrast(0);	/* ʃtF[hAEg */
					fadeout_music();	/* afltF[hAEg */
				}
				cnt--;
			}
			else {
				cnt = 0;
			}
		}
	}
	return	0;
}


/************************************************
    [hELN^I
		chr = LN^f[^obt@
		opr = obt@
	߂l	 TRUE : Q[s
		FALSE : I
 ************************************************/
Bool	select(CHR_DATA* chr[2], int opr[2])
{
	int	player, num[2];
	Bool	loop, loop2;

	if ( load_sprite(SPRITE_FILE, SPRITE_FILE, CODE0, PALET0) ) {
								/* XvCgǂݍ */
		return	FALSE;
	}
	play_select_bgm();					/* afltJn */
	start_select();						/* ʕ` */

	loop = TRUE;
	while ( loop ) {
		if ( (player = select_mode(opr)) < 0 ) {	/* [hI */
			return	FALSE;
		}

		if ( (opr[PLAYER1] == OPR_PLAYER) && (opr[PLAYER2] == OPR_PLAYER) ) {
								/* ΐ */
			num[PLAYER1] = PLAYER1;
			num[PLAYER2] = PLAYER2;
			switch ( select_chr(chr, num, 2, TRUE) ) {
			  case 0 :				/*  */
				loop = FALSE;
				break;
			  case 1 :				/* LZ */
				break;
			  default :				/* Q[I */
				return	FALSE;
			}
		}
		else {
			num[player ^ 0x01] = -1;
			loop2 = TRUE;
			while ( loop2 ) {
				num[player] = player;
				switch ( select_chr(chr, num, 1, FALSE) ) {
				  case 0 :
					num[player] = player ^ 0x01;
					switch ( select_chr(chr, num, 1, TRUE) ) {
					  case 0 :
						loop  = FALSE;
						loop2 = FALSE;
						break;
					  case 1 :
						break;
					  default :
						return	FALSE;
					}
					break;
				  case 1 :
					loop2 = FALSE;
					break;
				  default :
					return	FALSE;
				}
			}
		}
	}
	return	TRUE;
}


/************************************************
    I
		chr = LN^f[^obt@
		opr = obt@
 ************************************************/
void	auto_select(CHR_DATA* chr[2], int opr[2])
{
	chr[PLAYER1] = chr_data[rnd(CHR_MAX)];		/* LN^ */
	chr[PLAYER2] = chr_data[rnd(CHR_MAX)];
	opr[PLAYER1] = OPR_COM;				/* Rs[^ */
	opr[PLAYER2] = OPR_COM;
}

/********************** End of File *******************************************/