/*********************************************

	iV~[Vu΁v

				

 *********************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<sys\dos.h>
#include	<sys\iocs.h>

#include	"sakiba.h"
#include	"screen.h"
#include	"chranim.h"
#include	"pad.h"
#include	"pattern.h"


#define	SPRITE_FILE	"SAKIBA"		/* XvCgf[^ */

#define	CHR_CX		 32			/* LN^\ʒu */
#define	CHR_Y		100

#define	BAR_CX		  1			/* so[\ʒu */
#define	BAR_Y		128
#define	BAR_W		 10			/* PJEg̍so[̒ */
#define	BAR_H		  6
#define	BAR_NUM		 20			/* `悷o[̐ */

#define	HP_CX		  4			/* ̗͕\ʒu */
#define	HP_Y		  4
#define	HP_H		 12			/* ̗̓o[̍ */

#define	COL_HP		0xffd0			/* ̗̓o[̐F */
#define	COL_DAMAGE	0x27d0			/* _[W */
#define	COL_BACK	0x1408			/* n */

#define	NAME_X		  4			/* LN^\ʒu */
#define	NAME_Y		 20

#define	ACT_X1		  4			/* s\ʒu */
#define	ACT_X2		148
#define	ACT_Y		160
#define	ACT_H		 34

#define	MES_CX		128			/* bZ[W\ʒu */
#define	MES_CY		 64

/*** XvCgR[h *****/
#define	SPR_HITMARK	0x50d			/* qbg}[N */
#define	SPR_CURSOR	0x614			/* ̓J[\ */


static int		bar_count;		/* so[`̌ */
static int		message_num;		/* \bZ[Wԍ */
static int		hit_count;		/* qbg}[N */

unsigned short*	sprite_reg;			/* XvCg */
unsigned long	anim_count = 0;			/* Aj[VpJE^ */


static COLOR	bar_color[ACT_MAX] = {			/* so[̐F */
			0xe010,			/* h */
			0xffd8,			/* U */
			0xffd8,			/* U */
			0xfabe,			/* Ǔ */
			0x0708			/* U󂯂 */
		};

static unsigned short	message[MES_MAX][2] = {		/* bZ[W */
				{0x400, 4},	/* Ready */
				{0x104, 4},	/* Fight! */
				{0x108, 3},	/* K.O. */
				{0x40b, 2},	/* Win */
				{0x210, 2},	/* 1P */
				{0x312, 2}	/* 2P */
			};


/**********************
    Aԑ҂
 **********************/
void	v_synch(void)
{
	pad_synch();			/* pbh */
	rand();				/*  */
	anim_count++;			/* Aj[VpJE^ */

	while ( !(_iocs_b_bpeek((void *)0xe88001) & 0x10) );	/* A */
	while ( _iocs_b_bpeek((void *)0xe88001) & 0x10 );	/* \ */
}

/***************************************
    XvCg`
		code = p^[R[h
		x, y = `ʒu
 ***************************************/
void	put_sprite(CODE code, int x, int y)
{
	*sprite_reg++ = (unsigned short)x;		/* W */
	*sprite_reg++ = (unsigned short)y;		/* W */
	*sprite_reg++ = code;				/* p^[R[h */
	*sprite_reg++ = 3;				/* vCIeB */
}

/*********************************
    `
		 str = 
		x, y = `ʒu
 *********************************/
void	draw_str(char* str, short x, short y)
{
	struct _symbolptr	ptr;

	ptr.x1 = x + 1;			/* `ʒu */
	ptr.y1 = y + 1;
	ptr.string_address = str;	/*  */
	ptr.mag_x = 1;			/* { */
	ptr.mag_y = 1;
	ptr.color = 0x4110;		/* F */
	ptr.font_type = 1;		/* 16hbgtHg */
	ptr.angle = 0;			/* ]Ȃ */
	_iocs_symbol(&ptr);

	ptr.x1 = x;			/* `ʒu */
	ptr.y1 = y;
	ptr.color = 0xffff;		/* F */
	_iocs_symbol(&ptr);
}

/***************************************
    bZ[W`
		 num = bZ[Wԍ
		x, y = `撆Sʒu
 ***************************************/
void	draw_message(int num, short x, short y)
{
	CODE	code;
	int	n;

	code = (CODE)message[num][0];			/* XvCgR[h */
	   n =  (int)message[num][1];			/*  */
	x += -n*(16/2) + 16;
	y += 16;
	for (; n > 0; n--) {
		put_sprite(code++, x, y);
		x += 16;
	}
}


/********************
    bZ[W\
 ********************/
static
void	print_message(void)
{
	if ( message_num >= 0 ) {
		if ( message_num < MES_1P ) {
			draw_message(message_num, MES_CX, MES_CY);
		}
		else {
			draw_message(message_num, MES_CX - 16, MES_CY);
			draw_message(MES_WIN,     MES_CX + 16, MES_CY);
		}
	}
}

void	draw_bar(int, int, COLOR, COLOR, Bool);		/* o[` */

/*************************************
    so[`
		 act = s
		x, y = `ʒu
		half = 炷
		 inp = ͒
 *************************************/
static
void	draw_act_bar(ACTION* act, int x, int y, Bool half, Bool inp)
{
	ACTION*	p;
	COLOR	col1, col2;
	int	i, n, cnt;

	p = act;					/* s */
	n = -1;
	if ( (cnt = p->count) == 0 ) {
		n = 8;
		p++;
		cnt = p->count;
	}
	for (i = 0; i < bar_count; i++) {
		if ( n < 0 ) {				/* s\ */
			col1 = bar_color[p->kind];
			col2 = (((p->kind == ACT_ATTACK1) || (p->kind == ACT_ATTACK2))
							 && (cnt == 1)) ? 0x07c0 : 0x0000;
		}
		else if ( n > 0 ) {			/* s\ */
			col1 = (inp && ((anim_count + n/2)/32 % 2))
					? 0x0000 : (COLOR)(((n*3 - 1) << 11) |
							((n*3 - 1) << 6) | ((n*3 - 1) << 1));
			col2 = 0x0000;
		}
		else {					/* s */
			col1 = 0x0000;
			col2 = 0x0000;
		}

		if ( half && (i == 0) ) {		/* 炷 */
			draw_bar(x, y, col1, col2, TRUE);
			y += BAR_H/2;
		}
		else {
			draw_bar(x, y, col1, col2, FALSE);
			y += BAR_H;
		}

		if ( n < 0 ) {
			if ( --cnt == 0 ) {		/* ̍s */
				if ( (p->kind != ACT_ATTACK1) && (p->kind != ACT_ATTACK2) ) {
					p++;
					n = ((p->kind >= 0) || (mode == MODE_INPUT)) ? 8 : 0;
				}
				else {
					p++;
					cnt = p->count;
				}
			}
		}
		else if ( n > 0 ) {
			n--;
		}
	}
}

/**************
    ̗͕`
 **************/
static
void	draw_hp(void)
{
	struct _fillptr	ptr;
	CHR_PARAM*	chr;
	short		x;

	ptr.y1 = HP_Y;
	ptr.y2 = HP_Y + HP_H - 1;

	chr = &chr_param[PLAYER1];			/* vC[P */
	x = 128 - HP_CX;
	if ( chr->hit_point > 0 ) {			/* ̗ */
		ptr.x1 = x - chr->hit_point;
		ptr.x2 = x - 1;
		ptr.color = COL_HP;
		_iocs_fill(&ptr);
	}
	if ( chr->hit_point < chr->d_hp ) {		/* _[W */
		ptr.x1 = x - chr->d_hp;
		ptr.x2 = x - chr->hit_point - 1;
		ptr.color = COL_DAMAGE;
		_iocs_fill(&ptr);
		if ( anim_count % 2 ) {
			chr->d_hp--;
		}
	}
	if ( chr->d_hp < HP_MAX ) {			/* n */
		ptr.x1 = x - HP_MAX;
		ptr.x2 = x - chr->d_hp - 1;
		ptr.color = COL_BACK;
		_iocs_fill(&ptr);
	}

	chr = &chr_param[PLAYER2];			/* vC[Q */
	x = 128 + HP_CX;
	if ( chr->hit_point > 0 ) {			/* ̗ */
		ptr.x1 = x;
		ptr.x2 = x + chr->hit_point - 1;
		ptr.color = COL_HP;
		_iocs_fill(&ptr);
	}
	if ( chr->hit_point < chr->d_hp ) {		/* _[W */
		ptr.x1 = x + chr->hit_point;
		ptr.x2 = x + chr->d_hp - 1;
		ptr.color = COL_DAMAGE;
		_iocs_fill(&ptr);
		if ( (anim_count % 4) == 0 ) {
			chr->d_hp--;
		}
	}
	if ( chr->d_hp < HP_MAX ) {			/* n */
		ptr.x1 = x + chr->d_hp;
		ptr.x2 = x + HP_MAX - 1;
		ptr.color = COL_BACK;
		_iocs_fill(&ptr);
	}
}

/********************
    LN^`
 ********************/
static
void	draw_chr(void)
{
	int	i, j, k;

	if ( mode == MODE_INPUT ) {
		put_sprite(SPR_CURSOR + ((anim_count/8) % 3),
				(turn == PLAYER1) ? (128 - CHR_CX + 8) : (128 + CHR_CX + 8),
										CHR_Y - 20);
							/* ̓J[\` */
	}
	for (i = 0; i < 2; i++) {
		for (j = 0; j < 2; j++) {
			if ( turn == (i ^ j) ) {
				for (k = 0; k < 2; k++) {
					draw_pat(&chr_param[j].spr[1 - k], j,
						(j == PLAYER1) ? (128 - CHR_CX)
								: (128 + CHR_CX),
										CHR_Y);
							/* LN^p^[` */
				}
			}
		}
		if ( (i == 0) && (hit_count > 0) ) {
			put_sprite(SPR_HITMARK + ((hit_count > 12) ? (14 - hit_count) : 2),
				(turn == PLAYER1) ? (128 + CHR_CX + 8) : (128 - CHR_CX + 8),
										CHR_Y + 8);
							/* qbg}[N` */
			hit_count--;
		}
	}
}

/**************
    ʕ`
 **************/
void	draw_screen(void)
{
	int	ssp;

	ssp = _iocs_b_super(0);			/* X[p[oCU[h */
	sprite_reg = SPRITE_REG;		/* XvCgWX^擪 */
	v_synch();				/*  */

	print_message();			/* bZ[W` */
	draw_chr();				/* LN^` */
	if ( bar_count < BAR_NUM ) {		/* so[` */
		bar_count++;
	}
	draw_act_bar(chr_param[PLAYER1].action, 128 - BAR_CX - BAR_W, BAR_Y,
			(turn != PLAYER1), ((mode == MODE_INPUT) && (turn == PLAYER1)));
	draw_act_bar(chr_param[PLAYER2].action, 128 + BAR_CX, BAR_Y,
			(turn != PLAYER2), ((mode == MODE_INPUT) && (turn == PLAYER2)));
						/* so[` */
	draw_hp();				/* ̗͕` */

	while ( (unsigned long)sprite_reg < (unsigned long)(SPRITE_REG + 4*0x100) ) {
		sprite_reg += 3;
		*sprite_reg++ = 0;		/* XvCg\ */
	}
	_iocs_b_super(ssp);			/* [U[[h */
}


/**********************************
    so[Xɕ`
		f = `҂
 **********************************/
void	slow_bar(Bool f)
{
	bar_count = 0;				/* so[` */
	if ( f ) {
		while ( bar_count < BAR_NUM ) {
			draw_screen();		/* ʕ` */
			if ( esc_key ) {
				return;
			}
		}
	}
}

/**************************************
    \bZ[Wݒ
		num = bZ[Wԍ
 **************************************/
void	set_message(int num)
{
	message_num = num;
}

/**********************
    qbg}[Nݒ
 **********************/
void	set_hitmark(void)
{
	hit_count = 14;
}


/*********************************************
    p^[`
		 pat = OtBbNp^[
		x, y = `ʒu
 *********************************************/
static
void	draw_g_pattern(COLOR* pat, short x, short y)
{
	struct _putptr	ptr;

	ptr.x1 = x;			/* `ʒu */
	ptr.y1 = y;
	ptr.x2 = x + 16 - 1;
	ptr.y2 = y + 16 - 1;
	ptr.buf_start = pat;		/* OtBbNp^[ */
	ptr.buf_end   = pat + 16*16;
	_iocs_putgrm(&ptr);
}

/*********************************
    so[`ij
		x, y = `ʒu
		 num = 
		 col = F
 *********************************/
static
void	draw_bar2(short x, short y, int num, COLOR col)
{
	struct _fillptr	ptr;

	ptr.x1 = x;				/* `ʒu */
	ptr.x2 = x + BAR_H - 2;
	ptr.y1 = y;
	ptr.y2 = y + BAR_W - 1;
	ptr.color = col;			/* F */
	for (; num > 0; num--) {
		_iocs_fill(&ptr);
		ptr.x1 += BAR_H;
		ptr.x2 += BAR_H;
	}
}

/**********************************
    s`
		num = vC[
 **********************************/
static
void	draw_action(int num)
{
	CHR_DATA*	chr;
	short		x, y;

	chr = chr_param[num].data;			/* LN^f[^ */
	x = (num == PLAYER1) ? ACT_X1 : ACT_X2;
	y = ACT_Y;

	draw_g_pattern((num == PLAYER1) ? l_arrow : r_arrow, x, y);
	draw_bar2(x + 28, y + 12, GUARD_CNT, bar_color[ACT_GUARD]);
	draw_str("h", x + 18, y);			/* h */
	y += ACT_H;

	draw_g_pattern((num == PLAYER1) ? r_arrow : l_arrow, x, y);
	draw_bar2(x + 28, y + 12, chr->attack1.before, bar_color[ACT_ATTACK1]);
	draw_bar2(x + 28 + chr->attack1.before*BAR_H, y + 12,
						chr->attack1.after, bar_color[ACT_SUKI]);
	draw_str(chr->attack1.name, x + 18, y);		/* U */
	y += ACT_H;

	draw_g_pattern(u_arrow, x, y);
	draw_bar2(x + 28, y + 12, chr->attack2.before, bar_color[ACT_ATTACK2]);
	draw_bar2(x + 28 + chr->attack2.before*BAR_H, y + 12,
						chr->attack2.after, bar_color[ACT_SUKI]);
	draw_str(chr->attack2.name, x + 18, y);		/* U */
}

/******************
    ʕ`
 ******************/
void	draw_start(void)
{
	_iocs_wipe();				/* OtBbNNA */

	draw_str(chr_param[PLAYER1].data->name, NAME_X, NAME_Y);
	draw_str(chr_param[PLAYER2].data->name,
			256 - NAME_X - strlen(chr_param[PLAYER2].data->name)*8, NAME_Y);
						/* LN^` */

	draw_action(PLAYER1);			/* s` */
	draw_action(PLAYER2);

	bar_count = BAR_NUM;			/* so[` */
	set_message(-1);			/* bZ[W */

	_iocs_contrast(-2);			/* tF[hC */
}


/*****************************************************
    XvCgf[^ǂݍ
		 sp_name = XvCgt@Cl[
		pal_name = pbgt@Cl[
		      sp = 擪R[h
		     pal = 擪pbg
	߂l	0 : ǂݍ݊
		1 : ǂݍݎs
 *****************************************************/
int	load_sprite(char* sp_name, char* pal_name, int sp, int pal)
{
	FILE*	fp;
	char	*buf, *p;
	unsigned short*	c;
	int	i, j, size;

	if ( (buf = malloc(0x8000)) == NULL ) {
		eprintf("܂\n");
		return	1;
	}

	sprintf(buf, "%s.SP", sp_name);				/* p^[f[^ */
	if ( (fp = fopen(buf, "rb")) == NULL ) {
		eprintf("p^[t@C \"%s\" J܂\n", buf);
		return	1;
	}
	size = fread(buf, 0x80, 0x100, fp);
	fclose(fp);

	for (i = 0, p = buf; i < size; i++, p += 0x80) {
		_iocs_sp_defcg(sp++, 1, p);			/* XvCg` */
	}

	sprintf(buf, "%s.PAL", pal_name);			/* pbgf[^ */
	if ( (fp = fopen(buf, "rb")) == NULL ) {
		eprintf("pbgt@C \"%s\" J܂\n", buf);
		return	1;
	}
	size = fread(buf, sizeof(short)*0x10, 0x0f, fp);
	fclose(fp);

	c = (unsigned short*)buf;
	for (j = 0; j < size; j++, pal++) {
		for (i = 0; i < 0x10; i++) {
			_iocs_spalet(i + (1 << 0x1f), pal, (int)*c++);
								/* pbg` */
		}
	}

	free(buf);
	return	0;
}

/********************************
    ʏ
	߂l	0 : 
		1 : s
 ********************************/
int	init_screen(void)
{
	_iocs_contrast(0);				/* tF[hAEg */
	_iocs_sp_init();				/* XvCgʏ */
	_iocs_sp_on();					/* XvCgʕ\ */
	if ( load_sprite(SPRITE_FILE, SPRITE_FILE, 0x00, 0x01) ) {
							/* XvCgǂݍ */
		return	1;
	}
	return	0;
}

/************************ End of File *************************************************/